Commit | Line | Data |
---|---|---|
4132e8ca | 1 | #!/bin/sh |
2 | # some elements originated from qemu configure | |
3 | set -e | |
4 | ||
5 | TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c" | |
6 | TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o" | |
07c13dfd | 7 | TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}" |
8 | trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM | |
4132e8ca | 9 | rm -f config.log |
10 | ||
11 | compile_object() | |
12 | { | |
07c13dfd | 13 | c="$CC $CFLAGS -c $TMPC -o $TMPO $@" |
14 | echo $c >> config.log | |
15 | $c >> config.log 2>&1 | |
16 | } | |
17 | ||
18 | compile_binary() | |
19 | { | |
20 | c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@" | |
4132e8ca | 21 | echo $c >> config.log |
22 | $c >> config.log 2>&1 | |
23 | } | |
24 | ||
25 | check_define() | |
26 | { | |
cc376814 | 27 | $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1 |
28 | return 0 | |
29 | } | |
30 | ||
31 | check_define_val() | |
32 | { | |
33 | $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}' | |
4132e8ca | 34 | return 0 |
35 | } | |
36 | ||
37 | # setting options to "yes" or "no" will make that choice default, | |
38 | # "" means "autodetect". | |
39 | ||
38c2028e | 40 | platform_list="generic pandora maemo caanoo libretro" |
4132e8ca | 41 | platform="generic" |
0bfe8d59 | 42 | builtin_gpu_list="peops unai neon senquack" |
61bc6d40 | 43 | builtin_gpu="" |
b68bf5c2 | 44 | sound_driver_list="oss alsa pulseaudio sdl libretro" |
07c13dfd | 45 | sound_drivers="" |
dd4d5a35 | 46 | plugins="plugins/spunull/spunull.so \ |
0bfe8d59 | 47 | plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so plugins/gpu_senquack/gpu_senquack.so" |
4132e8ca | 48 | drc_cache_base="no" |
00a212aa | 49 | have_armv5="" |
4132e8ca | 50 | have_armv6="" |
51 | have_armv7="" | |
52 | have_arm_neon="" | |
53 | have_tslib="" | |
5b9aa749 | 54 | have_gles="" |
5514a050 | 55 | have_c64x_dsp="" |
4132e8ca | 56 | enable_dynarec="yes" |
f89fa2d9 | 57 | need_sdl="no" |
955f9af0 | 58 | need_xlib="no" |
cc56203b | 59 | need_libpicofe="yes" |
60 | need_warm="no" | |
5b9aa749 | 61 | CFLAGS_GLES="" |
62 | LDLIBS_GLES="" | |
4132e8ca | 63 | # these are for known platforms |
64 | optimize_cortexa8="no" | |
65 | optimize_arm926ej="no" | |
66 | ||
67 | # hardcoded stuff | |
68 | CC="${CC-${CROSS_COMPILE}gcc}" | |
ac6575cd | 69 | CXX="${CXX-${CROSS_COMPILE}g++}" |
4132e8ca | 70 | AS="${AS-${CROSS_COMPILE}as}" |
71 | AR="${AS-${CROSS_COMPILE}ar}" | |
9aff1963 | 72 | MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread" |
4132e8ca | 73 | config_mak="config.mak" |
74 | ||
07c13dfd | 75 | fail() |
76 | { | |
77 | echo "$@" | |
5d53bb85 | 78 | if test -n "$DUMP_CONFIG_LOG"; then cat config.log; fi |
07c13dfd | 79 | exit 1 |
80 | } | |
81 | ||
4132e8ca | 82 | # call during arg parsing, so that cmd line can override platform defaults |
83 | set_platform() | |
84 | { | |
85 | platform=$1 | |
86 | case "$platform" in | |
87 | generic) | |
88 | ;; | |
89 | pandora) | |
07c13dfd | 90 | sound_drivers="oss alsa" |
4132e8ca | 91 | drc_cache_base="yes" |
92 | optimize_cortexa8="yes" | |
93 | have_arm_neon="yes" | |
955f9af0 | 94 | need_xlib="yes" |
4132e8ca | 95 | ;; |
96 | maemo) | |
4132e8ca | 97 | drc_cache_base="yes" |
98 | optimize_cortexa8="yes" | |
99 | have_arm_neon="yes" | |
100 | ;; | |
101 | caanoo) | |
07c13dfd | 102 | sound_drivers="oss" |
4132e8ca | 103 | drc_cache_base="yes" |
104 | optimize_arm926ej="yes" | |
cc56203b | 105 | need_warm="yes" |
4132e8ca | 106 | ;; |
38c2028e | 107 | libretro) |
07c13dfd | 108 | sound_drivers="libretro" |
cc56203b | 109 | need_libpicofe="no" |
38c2028e | 110 | ;; |
4132e8ca | 111 | *) |
07c13dfd | 112 | fail "unsupported platform: $platform" |
4132e8ca | 113 | ;; |
114 | esac | |
115 | } | |
116 | ||
117 | for opt do | |
118 | optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true | |
119 | case "$opt" in | |
120 | --help|-h) show_help="yes" | |
121 | ;; | |
122 | --platform=*) set_platform "$optarg" | |
123 | ;; | |
61bc6d40 | 124 | --gpu=*) builtin_gpu="$optarg" |
125 | ;; | |
07c13dfd | 126 | --sound-drivers=*) sound_drivers="$optarg" |
4132e8ca | 127 | ;; |
128 | --enable-neon) have_arm_neon="yes" | |
129 | ;; | |
130 | --disable-neon) have_arm_neon="no" | |
131 | ;; | |
132 | --disable-dynarec) enable_dynarec="no" | |
133 | ;; | |
134 | *) echo "ERROR: unknown option $opt"; show_help="yes" | |
135 | ;; | |
136 | esac | |
137 | done | |
138 | ||
139 | if [ "$show_help" = "yes" ]; then | |
140 | echo "options:" | |
141 | echo " --help print this message" | |
142 | echo " --platform=NAME target platform [$platform]" | |
143 | echo " available: $platform_list" | |
61bc6d40 | 144 | echo " --gpu=NAME builtin gpu plugin [guessed]" |
145 | echo " available: $builtin_gpu_list" | |
07c13dfd | 146 | echo " --sound-drivers=LIST sound output drivers [guessed]" |
4132e8ca | 147 | echo " available: $sound_driver_list" |
148 | echo " --enable-neon" | |
149 | echo " --disable-neon enable/disable ARM NEON optimizations [guessed]" | |
150 | echo " --disable-dynarec disable dynamic recompiler" | |
151 | echo " (dynarec is only available and enabled on ARM)" | |
943a507a | 152 | echo " --disable-icache-emu Disables the instruction cache emulation" |
4132e8ca | 153 | echo "influential environment variables:" |
ac6575cd | 154 | echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS" |
4132e8ca | 155 | exit 1 |
156 | fi | |
157 | ||
07c13dfd | 158 | # validate selections |
61bc6d40 | 159 | if [ "x$builtin_gpu" != "x" ]; then |
07c13dfd | 160 | if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then |
161 | fail "unsupported builtin gpu plugin: $builtin_gpu" | |
162 | fi | |
61bc6d40 | 163 | fi |
164 | ||
07c13dfd | 165 | if [ "x$sound_drivers" != "x" ]; then |
166 | for d in $sound_drivers; do | |
167 | if ! echo $sound_driver_list | grep -q "\<$d\>"; then | |
168 | fail "unsupported sound driver: $sound_driver" | |
169 | fi | |
170 | done | |
171 | fi | |
4132e8ca | 172 | |
cc56203b | 173 | if [ "$need_libpicofe" = "yes" ]; then |
174 | if ! test -f "frontend/libpicofe/README"; then | |
175 | fail "libpicofe is missing, please run 'git submodule init && git submodule update'" | |
176 | fi | |
177 | fi | |
178 | ||
179 | if [ "$need_warm" = "yes" ]; then | |
180 | if ! test -f "frontend/warm/README"; then | |
181 | fail "wARM is missing, please run 'git submodule init && git submodule update'" | |
182 | fi | |
183 | fi | |
184 | ||
00a212aa | 185 | # basic compiler test |
186 | cat > $TMPC <<EOF | |
187 | #include <zlib.h> | |
188 | int main(void) { return 0; } | |
189 | EOF | |
190 | if ! compile_binary; then | |
0dc1b4a9 | 191 | fail "compiler test failed, please check config.log" |
00a212aa | 192 | fi |
193 | ||
4132e8ca | 194 | if [ -z "$ARCH" ]; then |
0dc1b4a9 | 195 | ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'` |
4132e8ca | 196 | fi |
197 | ||
0dc1b4a9 | 198 | case "$ARCH" in |
199 | arm*) | |
200 | # ARM stuff | |
201 | ARCH="arm" | |
202 | ||
4132e8ca | 203 | if [ "$optimize_cortexa8" = "yes" ]; then |
4132e8ca | 204 | CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8" |
205 | ASFLAGS="$ASFLAGS -mcpu=cortex-a8" | |
206 | fi | |
207 | if [ "$optimize_arm926ej" = "yes" ]; then | |
208 | CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s" | |
209 | ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp" | |
210 | fi | |
211 | ||
212 | if [ "x$have_arm_neon" = "x" ]; then | |
213 | # detect NEON from user-supplied cflags to enable asm code | |
214 | have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true | |
215 | fi | |
4132e8ca | 216 | if [ "x$have_armv7" = "x" ]; then |
00a212aa | 217 | if check_define HAVE_ARMV7; then |
4132e8ca | 218 | have_armv7="yes" |
00a212aa | 219 | have_armv6="yes" |
220 | have_armv5="yes" | |
4132e8ca | 221 | fi |
222 | fi | |
00a212aa | 223 | if [ "x$have_armv6" = "x" ]; then |
224 | if check_define HAVE_ARMV6; then | |
225 | have_armv6="yes" | |
226 | have_armv5="yes" | |
227 | fi | |
228 | fi | |
229 | if [ "x$have_armv5" = "x" ]; then | |
230 | have_armv5=`check_define HAVE_ARMV5 && echo yes` || true | |
231 | fi | |
4132e8ca | 232 | |
61bc6d40 | 233 | if [ "x$builtin_gpu" = "x" ]; then |
234 | if [ "$have_arm_neon" = "yes" ]; then | |
235 | builtin_gpu="neon" | |
236 | elif [ "$have_armv7" != "yes" ]; then | |
237 | # pre-ARMv7 hardware is usually not fast enough for peops | |
238 | builtin_gpu="unai" | |
239 | else | |
240 | builtin_gpu="peops" | |
241 | fi | |
242 | fi | |
243 | ||
e795af9e | 244 | # automatically set mfpu and mfloat-abi if they are not set |
4132e8ca | 245 | if [ "$have_arm_neon" = "yes" ]; then |
40cf6975 | 246 | fpu="neon" |
4132e8ca | 247 | elif [ "$have_armv6" = "yes" ]; then |
40cf6975 | 248 | fpu="vfp" |
4132e8ca | 249 | fi |
40cf6975 | 250 | if [ "x$fpu" != "x" ]; then |
251 | echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu" | |
252 | echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu" | |
253 | floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true | |
254 | if [ "$floatabi_set_by_gcc" != "yes" ]; then | |
255 | echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp" | |
256 | echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp" | |
257 | fi | |
4132e8ca | 258 | fi |
259 | ||
9f704290 | 260 | # must disable thumb as recompiler can't handle it |
96751f36 | 261 | if check_define __thumb__; then |
9f704290 | 262 | CFLAGS="$CFLAGS -marm" |
96751f36 | 263 | fi |
00a212aa | 264 | |
265 | # warn about common mistakes | |
266 | if [ "$have_armv5" != "yes" ]; then | |
267 | if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then | |
268 | echo "Warning: compiling for ARMv4, is that really what you want?" | |
269 | echo "You probably should specify -mcpu= or -march= like this:" | |
270 | echo " CFLAGS=-march=armv6 ./configure ..." | |
271 | fi | |
272 | fi | |
273 | if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then | |
274 | echo "Warning: compiling for NEON, but not ARMv7?" | |
275 | echo "You probably want to specify -mcpu= or -march= like this:" | |
276 | echo " CFLAGS=-march=armv7-a ./configure ..." | |
277 | fi | |
0dc1b4a9 | 278 | ;; |
55a2d0dc | 279 | aarch64) |
280 | ;; | |
0dc1b4a9 | 281 | *) |
4132e8ca | 282 | # dynarec only available on ARM |
283 | enable_dynarec="no" | |
0dc1b4a9 | 284 | ;; |
285 | esac | |
4132e8ca | 286 | |
61bc6d40 | 287 | if [ "x$builtin_gpu" = "x" ]; then |
288 | builtin_gpu="peops" | |
289 | fi | |
290 | ||
4132e8ca | 291 | # supposedly we can avoid -fPIC on armv5 for slightly better performace? |
292 | if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then | |
293 | PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC" | |
294 | fi | |
295 | ||
38c2028e | 296 | case "$platform" in |
297 | generic) | |
f89fa2d9 | 298 | need_sdl="yes" |
38c2028e | 299 | ;; |
300 | maemo) | |
7010034e | 301 | CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES" |
38c2028e | 302 | ;; |
303 | libretro) | |
304 | CFLAGS="$CFLAGS -fPIC" | |
22fa3f2b | 305 | MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined" |
38c2028e | 306 | ;; |
307 | esac | |
4132e8ca | 308 | |
07c13dfd | 309 | # header/library presence tests |
310 | check_zlib() | |
311 | { | |
312 | cat > $TMPC <<EOF | |
313 | #include <zlib.h> | |
791f6e3e | 314 | int main(void) { uncompress(0, 0, 0, 0); } |
07c13dfd | 315 | EOF |
316 | compile_binary | |
317 | } | |
318 | ||
07c13dfd | 319 | check_libpng() |
320 | { | |
321 | cat > $TMPC <<EOF | |
322 | #include <png.h> | |
323 | void main() { png_init_io(0, 0); } | |
324 | EOF | |
325 | compile_binary | |
326 | } | |
327 | ||
328 | check_oss() | |
329 | { | |
330 | cat > $TMPC <<EOF | |
331 | #include <sys/soundcard.h> | |
332 | #include <sys/ioctl.h> | |
333 | void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); } | |
334 | EOF | |
335 | compile_binary | |
336 | } | |
337 | ||
338 | check_alsa() | |
339 | { | |
340 | cat > $TMPC <<EOF | |
341 | #include <alsa/asoundlib.h> | |
342 | void main() { snd_pcm_open(0, 0, 0, 0); } | |
343 | EOF | |
344 | compile_binary "$@" | |
345 | } | |
346 | ||
b68bf5c2 | 347 | check_pulseaudio() |
348 | { | |
349 | cat > $TMPC <<EOF | |
350 | #include <pulse/pulseaudio.h> | |
351 | void main() { pa_threaded_mainloop_new(); } | |
352 | EOF | |
353 | compile_binary "$@" | |
354 | } | |
355 | ||
07c13dfd | 356 | check_sdl() |
357 | { | |
358 | cat > $TMPC <<EOF | |
359 | #include <SDL.h> | |
360 | void main() { SDL_OpenAudio(0, 0); } | |
361 | EOF | |
362 | compile_binary "$@" | |
363 | } | |
364 | ||
955f9af0 | 365 | check_xlib_headers() |
366 | { | |
367 | cat > $TMPC <<EOF | |
368 | #include <X11/Xlib.h> | |
369 | void *f() { return XOpenDisplay(0); } | |
370 | EOF | |
371 | compile_object "$@" | |
372 | } | |
373 | ||
5514a050 | 374 | # see if we have c64_tools for TI C64x DSP |
375 | check_c64_tools() | |
376 | { | |
377 | cat > $TMPC <<EOF | |
378 | #include <inc_libc64_mini.h> | |
379 | int f() { return dsp_open(); } | |
380 | EOF | |
381 | compile_object "$@" | |
382 | } | |
383 | ||
f89fa2d9 | 384 | MAIN_LDLIBS="$MAIN_LDLIBS -lz" |
9f704290 | 385 | check_zlib || fail "please install zlib (libz-dev)" |
f89fa2d9 | 386 | |
f89fa2d9 | 387 | MAIN_LDLIBS="-lpng $MAIN_LDLIBS" |
9f704290 | 388 | check_libpng || fail "please install libpng (libpng-dev)" |
07c13dfd | 389 | |
390 | # find what audio support we can compile | |
391 | if [ "x$sound_drivers" = "x" ]; then | |
392 | if check_oss; then sound_drivers="$sound_drivers oss"; fi | |
f89fa2d9 | 393 | if check_alsa -lasound; then |
394 | sound_drivers="$sound_drivers alsa" | |
395 | MAIN_LDLIBS="-lasound $MAIN_LDLIBS" | |
396 | fi | |
b68bf5c2 | 397 | if check_pulseaudio -lpulse; then |
398 | sound_drivers="$sound_drivers pulseaudio" | |
399 | MAIN_LDLIBS="-lpulse $MAIN_LDLIBS" | |
400 | fi | |
9f704290 | 401 | if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then |
f89fa2d9 | 402 | sound_drivers="$sound_drivers sdl" |
403 | need_sdl="yes" | |
404 | fi | |
405 | else | |
406 | if echo $sound_drivers | grep -q "\<oss\>"; then | |
407 | check_oss || fail "oss support is missing" | |
408 | fi | |
409 | if echo $sound_drivers | grep -q "\<alsa\>"; then | |
410 | MAIN_LDLIBS="-lasound $MAIN_LDLIBS" | |
411 | check_alsa || fail "please install libasound2-dev" | |
412 | fi | |
b68bf5c2 | 413 | if echo $sound_drivers | grep -q "\<pulseaudio\>"; then |
414 | MAIN_LDLIBS="-lpulse $MAIN_LDLIBS" | |
415 | check_pulseaudio || fail "pulseaudio support is missing" | |
416 | fi | |
07c13dfd | 417 | fi |
418 | ||
9f704290 | 419 | if [ "$need_sdl" = "yes" ]; then |
420 | which sdl-config > /dev/null || \ | |
421 | fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)" | |
f89fa2d9 | 422 | CFLAGS="$CFLAGS `sdl-config --cflags`" |
423 | MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS" | |
9f704290 | 424 | check_sdl || fail "please install libsdl (libsdl1.2-dev)" |
07c13dfd | 425 | fi |
426 | ||
4132e8ca | 427 | # check for tslib (only headers needed) |
428 | if [ "x$have_tslib" = "x" ]; then | |
429 | cat > $TMPC <<EOF | |
430 | #include <tslib.h> | |
431 | void test(struct ts_sample sample) {} | |
432 | EOF | |
433 | if compile_object; then | |
434 | have_tslib="yes" | |
435 | else | |
436 | have_tslib="no" | |
437 | fi | |
438 | fi | |
439 | ||
5b9aa749 | 440 | # check for VideoCore stuff for Raspberry Pi |
ad6150e0 | 441 | if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then |
237d1f6f | 442 | CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux" |
5b9aa749 | 443 | LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib" |
cbcadc5f | 444 | if [ -f /opt/vc/lib/libbcm_host.so ]; then |
445 | LDLIBS_GLES="$LDLIBS_GLES -lbcm_host" | |
446 | fi | |
955f9af0 | 447 | need_xlib="yes" |
ad6150e0 | 448 | VIDEOCORE="yes" |
5b9aa749 | 449 | fi |
450 | ||
dd4d5a35 | 451 | # check for GLES headers |
452 | cat > $TMPC <<EOF | |
453 | #include <GLES/gl.h> | |
dd4d5a35 | 454 | #include <EGL/egl.h> |
5b9aa749 | 455 | int main(void) { |
456 | return (int)eglGetDisplay( (EGLNativeDisplayType)0 ); | |
dd4d5a35 | 457 | } |
458 | EOF | |
ad6150e0 CG |
459 | if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then |
460 | have_gles="yes" | |
461 | LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES" | |
462 | elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then | |
5b9aa749 | 463 | have_gles="yes" |
464 | LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES" | |
465 | elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then | |
466 | have_gles="yes" | |
467 | LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES" | |
dd4d5a35 | 468 | fi |
469 | ||
5514a050 | 470 | if check_c64_tools; then |
471 | have_c64x_dsp="yes" | |
472 | fi | |
473 | ||
5b9aa749 | 474 | if [ "$have_gles" = "yes" ]; then |
475 | plugins="$plugins plugins/gpu-gles/gpu_gles.so" | |
476 | fi | |
61bc6d40 | 477 | if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then |
478 | plugins="$plugins plugins/gpu_neon/gpu_neon.so" | |
479 | fi | |
480 | ||
955f9af0 | 481 | # check for xlib (only headers needed) |
482 | if [ "x$need_xlib" = "xyes" ]; then | |
483 | check_xlib_headers || fail "please install libx11-dev" | |
484 | fi | |
485 | ||
cc376814 | 486 | sizeof_long=`check_define_val __SIZEOF_LONG__` |
487 | if [ "x$sizeof_long" = "x4" ]; then | |
488 | CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64" | |
489 | fi | |
490 | ||
9f704290 | 491 | cat > $TMPC <<EOF |
492 | void test(void *f, void *d) { fread(d, 1, 1, f); } | |
493 | EOF | |
494 | if compile_object -Wno-unused-result; then | |
495 | CFLAGS="$CFLAGS -Wno-unused-result" | |
496 | fi | |
497 | ||
dd4d5a35 | 498 | # short plugin list for display |
499 | for p in $plugins; do | |
500 | p1=`basename $p` | |
501 | plugins_short="$p1 $plugins_short" | |
502 | done | |
503 | ||
4132e8ca | 504 | # set things that failed to autodetect to "no" |
505 | test "x$have_armv6" != "x" || have_armv6="no" | |
506 | test "x$have_armv7" != "x" || have_armv7="no" | |
507 | test "x$have_arm_neon" != "x" || have_arm_neon="no" | |
00a212aa | 508 | test "x$have_gles" != "x" || have_gles="no" |
5514a050 | 509 | test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no" |
4132e8ca | 510 | |
511 | echo "architecture $ARCH" | |
512 | echo "platform $platform" | |
61bc6d40 | 513 | echo "built-in GPU $builtin_gpu" |
07c13dfd | 514 | echo "sound drivers $sound_drivers" |
dd4d5a35 | 515 | echo "plugins $plugins_short" |
4132e8ca | 516 | echo "C compiler $CC" |
517 | echo "C compiler flags $CFLAGS" | |
07c13dfd | 518 | echo "libraries $MAIN_LDLIBS" |
22fa3f2b | 519 | echo "linker flags $LDFLAGS$MAIN_LDFLAGS" |
4132e8ca | 520 | echo "enable dynarec $enable_dynarec" |
5514a050 | 521 | if [ "$ARCH" = "arm" ]; then |
522 | echo "ARMv7 optimizations $have_armv7" | |
523 | echo "enable ARM NEON $have_arm_neon" | |
524 | echo "TI C64x DSP support $have_c64x_dsp" | |
525 | fi | |
4132e8ca | 526 | echo "tslib support $have_tslib" |
2c616080 | 527 | if [ "$platform" = "generic" ]; then |
528 | echo "OpenGL ES output $have_gles" | |
529 | fi | |
4132e8ca | 530 | |
531 | echo "# Automatically generated by configure" > $config_mak | |
532 | printf "# Configured with:" >> $config_mak | |
533 | printf " '%s'" "$0" "$@" >> $config_mak | |
534 | echo >> $config_mak | |
535 | ||
536 | echo "CC = $CC" >> $config_mak | |
ac6575cd | 537 | echo "CXX = $CXX" >> $config_mak |
4132e8ca | 538 | echo "AS = $AS" >> $config_mak |
539 | echo "CFLAGS += $CFLAGS" >> $config_mak | |
540 | echo "ASFLAGS += $ASFLAGS" >> $config_mak | |
541 | echo "LDFLAGS += $LDFLAGS" >> $config_mak | |
22fa3f2b | 542 | echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak |
07c13dfd | 543 | echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak |
4132e8ca | 544 | echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak |
545 | echo >> $config_mak | |
546 | ||
38c2028e | 547 | if [ "$platform" = "libretro" ]; then |
548 | echo "TARGET = libretro.so" >> $config_mak | |
549 | fi | |
4132e8ca | 550 | echo "ARCH = $ARCH" >> $config_mak |
551 | echo "PLATFORM = $platform" >> $config_mak | |
61bc6d40 | 552 | echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak |
07c13dfd | 553 | echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak |
ddd99692 | 554 | echo "PLUGINS = $plugins" >> $config_mak |
4132e8ca | 555 | if [ "$have_arm_neon" = "yes" ]; then |
556 | echo "HAVE_NEON = 1" >> $config_mak | |
557 | fi | |
558 | if [ "$have_tslib" = "yes" ]; then | |
559 | echo "HAVE_TSLIB = 1" >> $config_mak | |
560 | fi | |
5b9aa749 | 561 | if [ "$have_gles" = "yes" ]; then |
562 | echo "HAVE_GLES = 1" >> $config_mak | |
563 | echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak | |
564 | echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak | |
565 | fi | |
4132e8ca | 566 | if [ "$enable_dynarec" = "yes" ]; then |
567 | echo "USE_DYNAREC = 1" >> $config_mak | |
568 | fi | |
569 | if [ "$drc_cache_base" = "yes" ]; then | |
2a014d73 | 570 | echo "BASE_ADDR_DYNAMIC = 1" >> $config_mak |
4132e8ca | 571 | fi |
5514a050 | 572 | if [ "$have_c64x_dsp" = "yes" ]; then |
573 | echo "HAVE_C64_TOOLS = 1" >> $config_mak | |
574 | fi | |
4132e8ca | 575 | |
2e6189bc | 576 | # use pandora's skin (for now) |
577 | test -e skin || ln -s frontend/pandora/skin skin | |
578 | ||
4132e8ca | 579 | # vim:shiftwidth=2:expandtab |